
Ti.include('suds.js');

var webServiceMethod = ["GetItemsList", "GetUOMList", "GetItemPriceList", "GetBankList", "GetBillReferanceList", "GetCategoryList", "GetPayTermsList", "GetPayModeList", "GetReasonList", "GetPriceGroupList", "GetCustomerAgentList", "GetServiceMasterList", "GetCurrencyUnitList", "GetCustomerProductList", "GetVanInventoryNew", "GetAgentListNew", "GetCreditNoteList", "GetCreditNoteItemsList", "GetInvoicesList", "GetInvoiceItemsList", "GetRouteMasterList", "GetRouteDetailsList", "GetSystemTable", "GetLocationList", "GetOrderHeaderList", "GetOrderItemsList", "GetCustomersList"];
var APIStatus = [];

var win = Titanium.UI.createWindow({  
    title:'Sample Web Service Call',
    backgroundColor:'#000'
});

var label = Titanium.UI.createLabel({
	color:'#fff',
	text:'Titanium HTTPClient Heap Memory Deallocation Issue Example',
	font:{fontSize:20,fontFamily:'Helvetica Neue'},
	textAlign:'center',
	width:'auto',
	top:'5%'
});

label.addEventListener('click',function(){
	WebserviceStart()
});

var button = Titanium.UI.createButton({
	title : "Start WebService Call",
	width : '50%',
	height : 60,
	borderRadius : 6,
	top:'10%'
});

button.addEventListener('click',function(){
	WebserviceStart()
});

var actInd = Titanium.UI.createActivityIndicator({
	font : {
		fontFamily : 'Helvetica Neue',
		fontSize : 30,
		fontWeight : 'bold'
	},
	color : 'white',
	message : 'Loading...',
	height : win.height,
	width : win.width,
	zIndex : 50
});

var suds = new SudsClient({
	endpoint : "http://meijiservice.cloudapp.net/Service.asmx",
	targetNamespace : "http://tempuri.org"
});

win.add(label);
win.add(button);
win.add(actInd);
win.open();


function WebserviceStart(){	
	var date = new Date();
	Ti.API.info("START TIME: " + date);
	var obj = {};
	APIStatus = [];
	obj.start = 0;
	obj.end = 2000;
	obj.action = webServiceMethod[0];
	actInd.show();
	webServiceCall(obj);
}

function webServiceCall(obj){	
	obj.callparams = {
		offset: obj.start,
	    length: obj.end,
	    mdtNo: "TAB015"
	};
	suds.invoke(obj.action, obj.callparams, function(xmlDoc, httpStatus) {
		var results = xmlDoc.documentElement.getElementsByTagName(obj.action+'Response');
		var result = results.item(0).text;
		var data = JSON.parse("["+result+"]");
		var totalLength = data[0].TotalLength[0].TotalLength;
		var totalAddedRecord = (parseInt(data[0].TotalLength[0].Length)+parseInt(data[0].TotalLength[0].Offset));
		Ti.API.info("Action:"+ obj.action +" TotalLength:"+totalLength+" Start:"+ (totalAddedRecord-2000) + "End:"+totalAddedRecord);
		if(totalLength==0 || totalLength<totalAddedRecord){
			if(APIStatus.indexOf(obj.action)<0){
				APIStatus.push(obj.action);
			}
			if(APIStatus.length == webServiceMethod.length){  
				var date = new Date();
				Ti.API.info("END TIME: " + date);
				alert("WEB SERVICE COMPLETED");
				actInd.hide();
			}else{
				obj.action = webServiceMethod[APIStatus.length];
				obj.start = 0;
				obj.end = 2000;
				webServiceCall(obj);
			}
		}else{
			obj.start = totalAddedRecord;
			obj.end = 2000;
			webServiceCall(obj);
		}
	});
}